﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Grafo_Consola
{
    class ClaseNodoGrafo : IComparable<ClaseNodoGrafo>, IEquatable<ClaseNodoGrafo>
    {
        // Dato del nodo
        private int dato;

        // Lista de arcos que "salen" del nodo
        private ClaseListaSimpleOrdenada<ClaseArcos> listaordenadaarcos;

        // Lista de arcos que "entran" al nodo
        private ClaseListaSimpleOrdenada<ClaseArcosInversos> listaordenadaarcosinversos;

        // Constructor
        public ClaseNodoGrafo()
        {
            // Crea la lista de arcos
            ListaOrdenadaArcos = new ClaseListaSimpleOrdenada<ClaseArcos>();

            // Crea la lista de arcos inversos
            ListaOrdenadaArcosInversos = new ClaseListaSimpleOrdenada<ClaseArcosInversos>();
        }

        // Propiedad pública para el dato del nodo
        public int Dato
        {
            get { return dato; }
            set { dato = value; }
        }

        // Propiedad pública para la lista de arcos
        public ClaseListaSimpleOrdenada<ClaseArcos> ListaOrdenadaArcos
        {
            get { return listaordenadaarcos; }
            set { listaordenadaarcos = value; }
        }

        // Propiedad pública para la lista de arcos inversos
        public ClaseListaSimpleOrdenada<ClaseArcosInversos> ListaOrdenadaArcosInversos
        {
            get { return listaordenadaarcosinversos; }
            set { listaordenadaarcosinversos = value; }
        }

        // Método público para comparar dos nodos de acuerdo a su dato
        // y establecer el criterio para mantenerlos ordenados
        public int CompareTo(ClaseNodoGrafo x)
        {
            return this.Dato.CompareTo(x.Dato);
        }

        // Método público para comparar dos nodos y determinar si son iguales
        public bool Equals(ClaseNodoGrafo x)
        {
            return this.Dato == x.Dato;
        }

        public override string ToString()
        {
            return Dato.ToString();
        }
    }
}
