﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Grafo_Consola
{
    class Program
    {
        static ClaseGrafoNoPonderadoDirigido GrafoNoPonderadoDirigido = new ClaseGrafoNoPonderadoDirigido();

        static void Main(string[] args)
        {
            Int16 opcion = 0;
            do
            {
                Console.Clear();
                Console.WriteLine("GRAFO NO PONDERADO Y DIRIGIDO");
                Console.WriteLine("\n1.- Cargar ejemplo prediseñado");
                Console.WriteLine("2.- Insertar nodo");
                Console.WriteLine("3.- Eliminar nodo");
                Console.WriteLine("4.- Buscar nodo");
                Console.WriteLine("5.- Mostrar nodos");
                Console.WriteLine("6.- Insertar arco");
                Console.WriteLine("7.- Eliminar arco");
                Console.WriteLine("8.- Búsqueda de camino en profundidad");
                Console.WriteLine("9.- Búsqueda de camino en anchura");
                Console.WriteLine("0.- Salir");
                Console.Write("\n\nOpcion ? ");
                opcion = Int16.Parse(Console.ReadLine());
                switch (opcion)
                {
                    case 1: CargarEjemplo(); break;
                    case 2: AgregarNodo(); break;
                    case 3: BorrarNodo(); break;
                    case 4: LocalizarNodo(); break;
                    case 5: MostrarNodos(); break;
                    case 6: AgregarArco(); break;
                    case 7: BorrarArco(); break;
                    case 8: Profundidad(); break;
                    case 9: Anchura(); break;
                }
            } while (opcion != 0);
        }

        static void CargarEjemplo()
        {
            GrafoNoPonderadoDirigido = new ClaseGrafoNoPonderadoDirigido();

            GrafoNoPonderadoDirigido.InsertarNodo(1);
            GrafoNoPonderadoDirigido.InsertarNodo(2);
            GrafoNoPonderadoDirigido.InsertarNodo(3);
            GrafoNoPonderadoDirigido.InsertarNodo(4);
            GrafoNoPonderadoDirigido.InsertarNodo(5);
            GrafoNoPonderadoDirigido.InsertarNodo(6);
            GrafoNoPonderadoDirigido.InsertarNodo(7);
            GrafoNoPonderadoDirigido.InsertarNodo(8);
            GrafoNoPonderadoDirigido.InsertarNodo(9);
            GrafoNoPonderadoDirigido.InsertarNodo(10);
            GrafoNoPonderadoDirigido.InsertarNodo(11);
            GrafoNoPonderadoDirigido.InsertarNodo(12);
            GrafoNoPonderadoDirigido.InsertarNodo(13);

            GrafoNoPonderadoDirigido.InsertarArco(1, 2);
            GrafoNoPonderadoDirigido.InsertarArco(1, 4);

            GrafoNoPonderadoDirigido.InsertarArco(2, 6);
            GrafoNoPonderadoDirigido.InsertarArco(2, 3);
            GrafoNoPonderadoDirigido.InsertarArco(2, 4);

            GrafoNoPonderadoDirigido.InsertarArco(3, 5);
            GrafoNoPonderadoDirigido.InsertarArco(3, 9);

            GrafoNoPonderadoDirigido.InsertarArco(4, 5);
            GrafoNoPonderadoDirigido.InsertarArco(4, 10);

            GrafoNoPonderadoDirigido.InsertarArco(5, 10);

            GrafoNoPonderadoDirigido.InsertarArco(6, 7);

            GrafoNoPonderadoDirigido.InsertarArco(7, 8);
            GrafoNoPonderadoDirigido.InsertarArco(7, 9);

            GrafoNoPonderadoDirigido.InsertarArco(8, 12);

            GrafoNoPonderadoDirigido.InsertarArco(9, 10);
            GrafoNoPonderadoDirigido.InsertarArco(9, 11);

            GrafoNoPonderadoDirigido.InsertarArco(10, 11);

            GrafoNoPonderadoDirigido.InsertarArco(11, 13);

            GrafoNoPonderadoDirigido.InsertarArco(12, 11);

            MostrarNodos();
        }

        static void AgregarNodo()
        {
            int Dato=0;

            Console.Clear();
            Console.WriteLine("INSERTAR NODO");
            Console.Write("\nNúmero del nodo ? ");
            Dato = int.Parse(Console.ReadLine());

            // Intenta insertar el dato en el Grafo
            try
            {
                GrafoNoPonderadoDirigido.InsertarNodo(Dato);
            }
            catch (Exception x)
            {
                Console.WriteLine("\n"+x.Message);
                Console.ReadKey();
                return;
            }

            Console.WriteLine("\nNodo insertado en el grafo");
            Console.ReadKey();
        }

        static void BorrarNodo()
        {
            int Dato = 0;

            Console.Clear();
            Console.WriteLine("BORRAR NODO");

            if (!GrafoNoPonderadoDirigido.EstaVacio())  // Si no está vacío ...
            {
                Console.Write("\nNúmero del nodo ? ");
                Dato = int.Parse(Console.ReadLine()); // Captura el dato del nodo que se desea borrar
            
                // Intenta eliminar el nodo del grafo
                try
                {
                    GrafoNoPonderadoDirigido.EliminarNodo(Dato);
                }
                catch (Exception x)  // Si ocurre un error ...
                {
                    Console.WriteLine("\n" + x.Message);
                    Console.ReadKey();
                    return;
                }
                Console.WriteLine("\nSe eliminó el nodo y sus arcos del grafo ...");
            }
            else
                Console.WriteLine("\nGrafo vacío ...");
            
            Console.ReadKey();
        }

        static void LocalizarNodo()
        {
            int Dato = 0;

            Console.Clear();
            Console.WriteLine("BUSCAR NODO");
            Console.Write("\nNúmero del nodo ? ");
            Dato = int.Parse(Console.ReadLine());

            if (GrafoNoPonderadoDirigido.BuscarNodo(Dato) != null)
                Console.WriteLine("\nEse nodo está almacenado en el grafo");
            else
                Console.WriteLine("\nEse nodo no existe en el grafo...");
            Console.ReadKey();
        }

        static void AgregarArco()
        {
            int DatoOrigen, DatoDestino;

            Console.Clear();
            Console.WriteLine("INSERTAR ARCO");

            if (!GrafoNoPonderadoDirigido.EstaVacio())  // Si no está vacío ...
            {
                Console.Write("\n\nNúmero del nodo origen ? ");
                DatoOrigen = int.Parse(Console.ReadLine());  // Captura el dato del nodo origen

                // Verifica la existencia del nodo origen
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoOrigen) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                Console.Write("\n\nNúmero del nodo destino ? ");
                DatoDestino = int.Parse(Console.ReadLine());  // Captura el dato del nodo destino

                // Verifica la existencia del nodo destino
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoDestino) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                // Intenta insertar el arco
                try
                {
                    GrafoNoPonderadoDirigido.InsertarArco(DatoOrigen, DatoDestino);
                }
                catch (Exception x)  // Si ocurre un error ...
                {
                    Console.WriteLine("\n" + x.Message);
                    Console.ReadKey();
                    return;
                }
                Console.WriteLine("\nArco insertado ...");
            }
            else
                Console.WriteLine("\nGrafo vacío ...");

            Console.ReadKey();
        }

        static void BorrarArco()
        {
            int DatoOrigen, DatoDestino;

            Console.Clear();
            Console.WriteLine("ELIMINAR ARCO");

            if (!GrafoNoPonderadoDirigido.EstaVacio())  // Si no está vacío ...
            {
                Console.Write("\n\nNúmero del nodo origen ? ");
                DatoOrigen = int.Parse(Console.ReadLine());  // Captura el dato del nodo origen

                // Verifica la existencia del nodo origen
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoOrigen) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                Console.Write("\n\nNúmero del nodo destino ? ");
                DatoDestino = int.Parse(Console.ReadLine());  // Captura el dato del nodo destino

                // Verifica la existencia del nodo destino
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoDestino) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                // Intenta eliminar el arco
                try
                {
                    GrafoNoPonderadoDirigido.EliminarArco(DatoOrigen, DatoDestino);
                }
                catch (Exception x)  // Si ocurre un error
                {
                    Console.WriteLine("\n" + x.Message);
                    Console.ReadKey();
                    return;
                }

                Console.WriteLine("\nArco eliminado ...");
            }
            else
                Console.WriteLine("\nGrafo vacío ...");

            Console.ReadKey();
        }

        static void MostrarNodos()
        {
            Console.Clear();
            Console.WriteLine("LISTA DE NODOS, ARCOS Y ARCOS INVERSOS ALMACENADOS EN EL GRAFO\n");

            Console.WriteLine(GrafoNoPonderadoDirigido.Mostrar());

            Console.ReadKey();
        }

        static void Profundidad()
        {
            int DatoOrigen, DatoDestino;
            string Resultado = "";

            Console.Clear();
            Console.WriteLine("BÚSQUEDA DE CAMINO EN PROFUNDIDAD");

            if (!GrafoNoPonderadoDirigido.EstaVacio())  // Si no está vacío ...
            {
                Console.Write("\n\nNúmero del nodo origen ? ");
                DatoOrigen = int.Parse(Console.ReadLine());  // Captura del dato del nodo origen

                // Verifica la existencia del nodo origen
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoOrigen) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                Console.Write("\n\nNúmero del nodo destino ? ");
                DatoDestino = int.Parse(Console.ReadLine());  // Captura el dato del nodo destino

                // Verifica la existencia del nodo destino
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoDestino) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                // Intenta ejecutar el método del recorrido en profundidad
                try
                {
                    Resultado = GrafoNoPonderadoDirigido.RecorridoProfundidad(DatoOrigen, DatoDestino);

                    Console.Write("\nCAMINO:\n" + Resultado);
                }
                catch (Exception x)  // Si ocurre un error ...
                {
                    Console.WriteLine("\n" + x.Message);
                    Console.ReadKey();
                    return;
                }

            }
            else
                Console.WriteLine("\nGrafo vacío ...");

            Console.ReadKey();
        }

        static void Anchura()
        {
            int DatoOrigen, DatoDestino;
            string Resultado = "";

            Console.Clear();
            Console.WriteLine("BÚSQUEDA DE CAMINO EN ANCHURA");

            if (!GrafoNoPonderadoDirigido.EstaVacio())  // Si no está vacío ...
            {
                Console.Write("\n\nNúmero del nodo origen ? ");
                DatoOrigen = int.Parse(Console.ReadLine());  // Captura del dato del nodo origen

                // Verifica la existencia del nodo origen
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoOrigen) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                Console.Write("\n\nNúmero del nodo destino ? ");
                DatoDestino = int.Parse(Console.ReadLine());  // Captura el dato del nodo destino

                // Verifica la existencia del nodo destino
                if (GrafoNoPonderadoDirigido.BuscarNodo(DatoDestino) == null)
                {
                    Console.WriteLine("\nEse nodo no existe en el grafo...");
                    Console.ReadKey();
                    return;
                }

                // Intenta ejecutar el método del recorrido en anchura
                try
                {
                    Resultado = GrafoNoPonderadoDirigido.RecorridoAnchura(DatoOrigen, DatoDestino);

                    Console.Write("\nCAMINO:\n" + Resultado);
                }
                catch (Exception x)  // Si ocurre un error ...
                {
                    Console.WriteLine("\n" + x.Message);
                    Console.ReadKey();
                    return;
                }

            }
            else
                Console.WriteLine("\nGrafo vacío ...");

            Console.ReadKey();
        }
    }
}
